require "spec_helper"

describe MotoRecall::RecallSet do
  it "is enumerable" do
    recalls = MotoRecall::RecallSet.new([1, 2, 3, 4])

    expect(recalls.respond_to?(:map)).to be true
    expect(recalls.respond_to?(:find)).to be true
    expect(recalls.respond_to?(:select)).to be true
    expect(recalls.respond_to?(:reduce)).to be true
  end

  it "allows recalls to be accessed directly through #items" do
    items = [1, 2, 3, 4]
    recalls = MotoRecall::RecallSet.new(items)
    expect(recalls.items).to eql(items)
  end

  it "contains the original response from the remote resource" do
    original_response = "The original http response from the remote resource"
    recalls = MotoRecall::RecallSet.new([1, 2, 3, 4], {
      original_response: original_response
    })

    expect(recalls.original_response).to eql(original_response)
  end
end
