require "spec_helper"

describe MotoRecall do
  describe "#find" do
    it "raises exception on invalid VIN" do
      expect do
        MotoRecall.find(:honda, "invalid")
      end.to raise_error(ArgumentError)
    end

    it "raises exception on invalid make" do
      expect do
        MotoRecall.find(:foobar, "5FNYF18218B043384")
      end.to raise_error(ArgumentError)
    end

    it "raises ClientException on certain rescuable exceptions" do
      # force Timeout::Error exception to ensure it is rescued
      allow_any_instance_of(MotoRecall::Client::GenericClient).to receive(:find) do
        raise Timeout::Error
      end

      expect do
        MotoRecall.find(:honda, "5FNYF18218B043384")
      end.to raise_error(MotoRecall::ClientException)
    end
  end
end
